clang-tools 10.0.0

Public Member Functions | List of all members
clang::tidy::bugprone::TooSmallLoopVariableCheck Class Reference

This check gives a warning if a loop variable has a too small type which might not be able to represent all values which are part of the whole range in which the loop iterates. More...

`#include <TooSmallLoopVariableCheck.h>`

Inheritance diagram for clang::tidy::bugprone::TooSmallLoopVariableCheck:
[legend]
Collaboration diagram for clang::tidy::bugprone::TooSmallLoopVariableCheck:
[legend]

## Public Member Functions
| TooSmallLoopVariableCheck (StringRef Name, ClangTidyContext *Context)
void | storeOptions (ClangTidyOptions::OptionMap &Opts) override
| Should store all options supported by this check with their current values or default values for options that haven't been overridden. More...
void | registerMatchers (ast_matchers::MatchFinder *Finder) override
| The matcher for loops with suspicious integer loop variable. More...
void | check (const ast_matchers::MatchFinder::MatchResult &Result) override
| `ClangTidyChecks` that register ASTMatchers should do the actual work in here. More...
Public Member Functions inherited from clang::tidy::ClangTidyCheck
| ClangTidyCheck (StringRef CheckName, ClangTidyContext *Context)
| Initializes the check with `CheckName` and `Context`. More...
virtual void | registerPPCallbacks (const SourceManager &SM, Preprocessor *PP, Preprocessor *ModuleExpanderPP)
| Override this to register `PPCallbacks` in the preprocessor. More...
DiagnosticBuilder | diag (SourceLocation Loc, StringRef Description, DiagnosticIDs::Level Level=DiagnosticIDs::Warning)
| Add a diagnostic with the check's name. More...

## Additional Inherited Members
Protected Member Functions inherited from clang::tidy::ClangTidyCheck
StringRef | getCurrentMainFile () const
| Returns the main file name of the current translation unit. More...
const LangOptions & | getLangOpts () const
| Returns the language options from the context. More...
Protected Attributes inherited from clang::tidy::ClangTidyCheck
OptionsView | Options

## Detailed Description

This check gives a warning if a loop variable has a too small type which might not be able to represent all values which are part of the whole range in which the loop iterates.

If the loop variable's type is too small we might end up in an infinite loop. Example:

long size = 294967296l;
for (short i = 0; i < size; ++i) {} { ... }

For the user-facing documentation see: http://clang.llvm.org/extra/clang-tidy/checks/bugprone-too-small-loop-variable.html

Definition at line 30 of file TooSmallLoopVariableCheck.h.

## Constructor & Destructor Documentation

## ◆ TooSmallLoopVariableCheck()

clang::tidy::bugprone::TooSmallLoopVariableCheck::TooSmallLoopVariableCheck | ( | StringRef | Name,
|  | ClangTidyContext * | Context
| ) |  |

Definition at line 30 of file TooSmallLoopVariableCheck.cpp.

## Member Function Documentation

## ◆ check()

void clang::tidy::bugprone::TooSmallLoopVariableCheck::check | ( | const ast_matchers::MatchFinder::MatchResult & | Result | ) |
| override virtual

`ClangTidyChecks` that register ASTMatchers should do the actual work in here.

Reimplemented from clang::tidy::ClangTidyCheck.

Definition at line 147 of file TooSmallLoopVariableCheck.cpp.

## ◆ registerMatchers()

void clang::tidy::bugprone::TooSmallLoopVariableCheck::registerMatchers | ( | ast_matchers::MatchFinder * | Finder | ) |
| override virtual

The matcher for loops with suspicious integer loop variable.

In this general example, assuming 'j' and 'k' are of integral type:

for (...; j < 3 + 2; ++k) { ... }

The following string identifiers are bound to these parts of the AST: LoopVarName: 'j' (as a VarDecl) LoopVarCastName: 'j' (after implicit conversion) LoopUpperBoundName: '3 + 2' (as an Expr) LoopIncrementName: 'k' (as an Expr) LoopName: The entire for loop (as a ForStmt)

Reimplemented from clang::tidy::ClangTidyCheck.

Definition at line 54 of file TooSmallLoopVariableCheck.cpp.

## ◆ storeOptions()

void clang::tidy::bugprone::TooSmallLoopVariableCheck::storeOptions | ( | ClangTidyOptions::OptionMap & | Options | ) |
| override virtual

Should store all options supported by this check with their current values or default values for options that haven't been overridden.

The check should use `Options.store()` to store each option it supports whether it has the default value or it has been overridden.

Reimplemented from clang::tidy::ClangTidyCheck.

Definition at line 36 of file TooSmallLoopVariableCheck.cpp.

The documentation for this class was generated from the following files:

- TooSmallLoopVariableCheck.h
- TooSmallLoopVariableCheck.cpp